using System;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Security.Permissions;
using Gtk;

namespace WeifenLuo.WinFormsUI.Docking
{
	public abstract class DockPaneCaptionBase : DrawingArea
	{
		protected internal DockPaneCaptionBase(DockPane pane)
		{
			m_dockPane = pane;

			/*SetStyle(ControlStyles.OptimizedDoubleBuffer |
                ControlStyles.ResizeRedraw |
                ControlStyles.UserPaint |
                ControlStyles.AllPaintingInWmPaint, true);
			SetStyle(ControlStyles.Selectable, false);*/
		}

		private DockPane m_dockPane;
		protected DockPane DockPane
		{
			get	{	return m_dockPane;	}
		}

		protected DockPane.AppearanceStyle Appearance
		{
			get	{	return DockPane.Appearance;	}
		}

        protected bool HasTabPageContextMenu
        {
            get { return DockPane.HasTabPageContextMenu; }
        }

        protected void ShowTabPageContextMenu(Gdk.Point position)
        {
            DockPane.ShowTabPageContextMenu(this, position);
        }

		protected override bool OnButtonReleaseEvent (Gdk.EventButton evnt)
		{
			if (evnt.Button == 1 && evnt.Type == Gdk.EventType.TwoButtonPress) {
                if (DockHelper.IsDockStateAutoHide(DockPane.DockState))
                {
                    DockPane.DockPanel.ActiveAutoHideContent = null;
                    return;
                }
			}

            if (evnt.Button == 3)
                ShowTabPageContextMenu(new Gdk.Point(evnt.X, evnt.Y));

			return base.OnButtonReleaseEvent (evnt);
		}

		protected override bool OnButtonPressEvent (Gdk.EventButton evnt)
		{
            if (evnt.Button == 1 &&
			    DockPane.DockPanel.AllowEndUserDocking &&
                DockPane.AllowDockDragAndDrop &&
				!DockHelper.IsDockStateAutoHide(DockPane.DockState) &&
                DockPane.ActiveContent != null)
				DockPane.DockPanel.BeginDrag(DockPane);

			return base.OnButtonPressEvent (evnt);
		}

		internal void RefreshChanges()
		{
           // if (IsDisposed)
           //     return;

			OnRefreshChanges();
		}

        protected virtual void OnRightToLeftLayoutChanged()
        {
        }

		protected virtual void OnRefreshChanges()
		{
		}

		protected internal abstract int MeasureHeight();
	}
}
