using System;
using System.Collections;
using System.ComponentModel;
using Gtk;
using Gdk;

namespace WeifenLuo.WinFormsUI.Docking
{
	internal class SplitterBase : Gtk.Widget
	{
		private DockStyle _DockStyle;

		public SplitterBase()
		{
			// TO-DO: set style
			//SetStyle(ControlStyles.Selectable, false);
		}

		public DockStyle Dock
		{
			get	{	return _DockStyle;	}
			set
			{
				_DockStyle = value;


				if (Dock == DockStyle.Left || Dock == DockStyle.Right)
					this.WidthRequest = SplitterSize;
				else if (Dock == DockStyle.Top || Dock == DockStyle.Bottom)
					this.HeightRequest = SplitterSize;
				// TO-DO
//				else
//					Bounds = Rectangle.Empty;

				if (Dock == DockStyle.Left || Dock == DockStyle.Right)
					this.GdkWindow.Cursor = new Cursor(CursorType.SbVDoubleArrow);
				else if (Dock == DockStyle.Top || Dock == DockStyle.Bottom)
					this.GdkWindow.Cursor = new Cursor(CursorType.SbHDoubleArrow);
				else
					this.GdkWindow.Cursor = new Cursor(CursorType.Arrow);
					
			}
		}

		protected virtual int SplitterSize
		{
			get	{	return 0;	}
		}

		protected override bool OnButtonPressEvent (EventButton evnt)
		{
			if (evnt.Button != 1)
				return;

			StartDrag();

			return base.OnButtonPressEvent (evnt);
		}


		protected virtual void StartDrag()
		{
		}

		/* TO-DO: do we need?
		protected override void WndProc(ref Message m)
		{
            // eat the WM_MOUSEACTIVATE message
			if (m.Msg == (int)Win32.Msgs.WM_MOUSEACTIVATE)
				return;

			base.WndProc(ref m);
		}*/
	}
}
